Public Member Functions

# OGRLayerDecorator Class Reference

Inheritance diagram for OGRLayerDecorator:

List of all members.

## Public Member Functions
virtual OGRGeometry * | GetSpatialFilter ()
| This method returns the current spatial filter for this layer.
virtual void | SetSpatialFilter (OGRGeometry *)
| Set a new spatial filter.
virtual void | SetSpatialFilterRect (double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter.
virtual void | SetSpatialFilter (int iGeomField, OGRGeometry *)
| Set a new spatial filter.
virtual void | SetSpatialFilterRect (int iGeomField, double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter.
virtual OGRErr | SetAttributeFilter (const char *)
| Set a new attribute query.
virtual void | ResetReading ()
| Reset feature reading to start on the first feature.
virtual OGRFeature * | GetNextFeature ()
| Fetch the next available feature from this layer.
virtual OGRErr | SetNextByIndex (long nIndex)
| Move read cursor to the nIndex'th feature in the current resultset.
virtual OGRFeature * | GetFeature (long nFID)
| Fetch a feature by its identifier.
virtual OGRErr | SetFeature (OGRFeature *poFeature)
| Rewrite an existing feature.
virtual OGRErr | CreateFeature (OGRFeature *poFeature)
| Create and write a new feature within a layer.
virtual OGRErr | DeleteFeature (long nFID)
| Delete feature from layer.
virtual const char * | GetName ()
| Return the layer name.
virtual OGRwkbGeometryType | GetGeomType ()
| Return the layer geometry type.
virtual OGRFeatureDefn * | GetLayerDefn ()
| Fetch the schema information for this layer.
virtual OGRSpatialReference * | GetSpatialRef ()
| Fetch the spatial reference system for this layer.
virtual int | GetFeatureCount (int bForce=TRUE)
| Fetch the feature count in this layer.
virtual OGRErr | GetExtent (int iGeomField, OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer, on the specified geometry field.
virtual OGRErr | GetExtent (OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer.
virtual int | TestCapability (const char *)
| Test if this layer supported the named capability.
virtual OGRErr | CreateField (OGRFieldDefn *poField, int bApproxOK=TRUE)
| Create a new field on a layer.
virtual OGRErr | DeleteField (int iField)
| Delete an existing field on a layer.
virtual OGRErr | ReorderFields (int *panMap)
| Reorder all the fields of a layer.
virtual OGRErr | AlterFieldDefn (int iField, OGRFieldDefn *poNewFieldDefn, int nFlags)
| Alter the definition of an existing field on a layer.
virtual OGRErr | SyncToDisk ()
| Flush pending changes to disk.
virtual OGRStyleTable * | GetStyleTable ()
| Returns layer style table.
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set layer style table.
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set layer style table.
virtual const char * | GetFIDColumn ()
| This method returns the name of the underlying database column being used as the FID column, or "" if not supported.
virtual const char * | GetGeometryColumn ()
| This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.
virtual OGRErr | SetIgnoredFields (const char **papszFields)
| Set which fields can be omitted when retrieving features from the layer.

## Member Function Documentation

OGRErr OGRLayerDecorator::AlterFieldDefn | ( | int | iField,
|  | OGRFieldDefn * | poNewFieldDefn,
|  | int | nFlags |
| ) |  |  | `[virtual]`

Alter the definition of an existing field on a layer.

You must use this to alter the definition of an existing field of a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the altered field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existance that were obtained or created with the previous layer definition.

Not all drivers support this method. You can query a layer to check if it supports it with the OLCAlterFieldDefn capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existings features of the backing file/database should be updated accordingly. Some drivers might also not support all update flags.

This function is the same as the C function OGR_L_AlterFieldDefn().

Parameters:

  | iField | index of the field whose definition must be altered.
  | poNewFieldDefn | new field definition
  | nFlags | combination of ALTER_NAME_FLAG, ALTER_TYPE_FLAG and ALTER_WIDTH_PRECISION_FLAG to indicate which of the name and/or type and/or width and precision fields from the new field definition must be taken into account.

Returns:
  OGRERR_NONE on success.

Since:
  OGR 1.9.0

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::AlterFieldDefn().

OGRErr OGRLayerDecorator::CreateFeature | ( | OGRFeature * | poFeature | ) | `[virtual]`

Create and write a new feature within a layer.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

This method is the same as the C function OGR_L_CreateFeature().

Parameters:

  | poFeature | the feature to write to disk.

Returns:
  OGRERR_NONE on success.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::CreateFeature().

OGRErr OGRLayerDecorator::CreateField | ( | OGRFieldDefn * | poField,
|  | int | bApproxOK = `TRUE` |
| ) |  |  | `[virtual]`

Create a new field on a layer.

You must use this to create new fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existance that were obtained or created with the previous layer definition.

Not all drivers support this method. You can query a layer to check if it supports it with the OLCCreateField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existings features of the backing file/database should be updated accordingly.

This function is the same as the C function OGR_L_CreateField().

Parameters:

  | poField | field definition to write to disk.
  | bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns:
  OGRERR_NONE on success.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::CreateField().

OGRErr OGRLayerDecorator::DeleteFeature | ( | long | nFID | ) | `[virtual]`

Delete feature from layer.

The feature with the indicated feature id is deleted from the layer if supported by the driver. Most drivers do not support feature deletion, and will return OGRERR_UNSUPPORTED_OPERATION. The TestCapability() layer method may be called with OLCDeleteFeature to check if the driver supports feature deletion.

This method is the same as the C function OGR_L_DeleteFeature().

Parameters:

  | nFID | the feature id to be deleted from the layer

Returns:
  OGRERR_NONE on success.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::DeleteFeature().

OGRErr OGRLayerDecorator::DeleteField | ( | int | iField | ) | `[virtual]`

Delete an existing field on a layer.

You must use this to delete existing fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the deleted field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existance that were obtained or created with the previous layer definition.

Not all drivers support this method. You can query a layer to check if it supports it with the OLCDeleteField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existings features of the backing file/database should be updated accordingly.

This function is the same as the C function OGR_L_DeleteField().

Parameters:

  | iField | index of the field to delete.

Returns:
  OGRERR_NONE on success.

Since:
  OGR 1.9.0

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::DeleteField().

OGRErr OGRLayerDecorator::GetExtent | ( | int | iGeomField,
|  | OGREnvelope * | psExtent,
|  | int | bForce = `TRUE` |
| ) |  |  | `[virtual]`

Fetch the extent of this layer, on the specified geometry field.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

Note to driver implementators: if you implement GetExtent(int,OGREnvelope*,int), you must also implement GetExtent(OGREnvelope*, int) to make it call GetExtent(0,OGREnvelope*,int).

This method is the same as the C function OGR_L_GetExtentEx().

Parameters:

  | iGeomField | the index of the geometry field on which to compute the extent.
  | psExtent | the structure in which the extent value will be returned.
  | bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns:
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetExtent().

OGRErr OGRLayerDecorator::GetExtent | ( | OGREnvelope * | psExtent,
|  | int | bForce = `TRUE` |
| ) |  |  | `[virtual]`

Fetch the extent of this layer.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

This method is the same as the C function OGR_L_GetExtent().

Parameters:

  | psExtent | the structure in which the extent value will be returned.
  | bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns:
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetExtent().

OGRFeature * OGRLayerDecorator::GetFeature | ( | long | nFID | ) | `[virtual]`

Fetch a feature by its identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters (and specialized implementations in drivers should make sure that they do not take into account spatial or attribute filters).

If this method returns a non-NULL feature, it is guaranteed that its feature id (OGRFeature::GetFID()) will be the same as nFID.

Use OGRLayer::TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads (with GetNextFeature()) are generally considered interrupted by a GetFeature() call.

The returned feature should be free with OGRFeature::DestroyFeature().

This method is the same as the C function OGR_L_GetFeature().

Parameters:

  | nFID | the feature id of the feature to read.

Returns:
  a feature now owned by the caller, or NULL on failure.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetFeature().

int OGRLayerDecorator::GetFeatureCount | ( | int | bForce = `TRUE` | ) | `[virtual]`

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

Note that some implementations of this method may alter the read cursor of the layer.

This method is the same as the C function OGR_L_GetFeatureCount().

Parameters:

  | bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns:
  feature count, -1 if count not known.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetFeatureCount().

const char * OGRLayerDecorator::GetFIDColumn | ( |  | ) | `[virtual]`

This method returns the name of the underlying database column being used as the FID column, or "" if not supported.

This method is the same as the C function OGR_L_GetFIDColumn().

Returns:
  fid column name.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetFIDColumn().

const char * OGRLayerDecorator::GetGeometryColumn | ( |  | ) | `[virtual]`

This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.

This method is the same as the C function OGR_L_GetGeometryColumn().

Returns:
  geometry column name.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetGeometryColumn().

OGRwkbGeometryType OGRLayerDecorator::GetGeomType | ( |  | ) | `[virtual]`

Return the layer geometry type.

This returns the same result as GetLayerDefn()->GetGeomType(), but for a few drivers, calling GetGeomType() directly can avoid lengthy layer definition initialization.

This method is the same as the C function OGR_L_GetGeomType().

If this method is derived in a driver, it must be done such that it returns the same content as GetLayerDefn()->GetGeomType().

Returns:
  the geometry type

Since:
  OGR 1.8.0

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetGeomType().

OGRFeatureDefn * OGRLayerDecorator::GetLayerDefn | ( |  | ) | `[virtual]`

Fetch the schema information for this layer.

The returned OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This method is the same as the C function OGR_L_GetLayerDefn().

Returns:
  feature definition.

Implements OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetLayerDefn().

const char * OGRLayerDecorator::GetName | ( |  | ) | `[virtual]`

Return the layer name.

This returns the same content as GetLayerDefn()->GetName(), but for a few drivers, calling GetName() directly can avoid lengthy layer definition initialization.

This method is the same as the C function OGR_L_GetName().

If this method is derived in a driver, it must be done such that it returns the same content as GetLayerDefn()->GetName().

Returns:
  the layer name (must not been freed)

Since:
  OGR 1.8.0

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetName().

OGRFeature * OGRLayerDecorator::GetNextFeature | ( |  | ) | `[virtual]`

Fetch the next available feature from this layer.

The returned feature becomes the responsiblity of the caller to delete with OGRFeature::DestroyFeature(). It is critical that all features associated with an OGRLayer (more specifically an OGRFeatureDefn) be deleted before that layer/datasource is deleted.

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This method implements sequential access to the features of a layer. The ResetReading() method can be used to start at the beginning again.

This method is the same as the C function OGR_L_GetNextFeature().

Returns:
  a feature, or NULL if no more features are available.

Implements OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetNextFeature().

OGRGeometry * OGRLayerDecorator::GetSpatialFilter | ( |  | ) | `[virtual]`

This method returns the current spatial filter for this layer.

The returned pointer is to an internally owned object, and should not be altered or deleted by the caller.

This method is the same as the C function OGR_L_GetSpatialFilter().

Returns:
  spatial filter geometry.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetSpatialFilter().

OGRSpatialReference * OGRLayerDecorator::GetSpatialRef | ( |  | ) | `[virtual]`

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

Starting with OGR 1.11, several geometry fields can be associated to a feature definition. Each geometry field can have its own spatial reference system, which is returned by OGRGeomFieldDefn::GetSpatialRef(). OGRLayer::GetSpatialRef() is equivalent to GetLayerDefn()->GetGeomFieldDefn(0)->GetSpatialRef()

This method is the same as the C function OGR_L_GetSpatialRef().

Returns:
  spatial reference, or NULL if there isn't one.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::GetSpatialRef().

OGRStyleTable * OGRLayerDecorator::GetStyleTable | ( |  | ) | `[virtual]`

Returns layer style table.

This method is the same as the C function OGR_L_GetStyleTable().

Returns:
  pointer to a style table which should not be modified or freed by the caller.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::GetStyleTable().

OGRErr OGRLayerDecorator::ReorderFields | ( | int * | panMap | ) | `[virtual]`

Reorder all the fields of a layer.

You must use this to reorder existing fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the reordering of the fields. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existance that were obtained or created with the previous layer definition.

panMap is such that,for each field definition at position i after reordering, its position before reordering was panMap[i].

For example, let suppose the fields were "0","1","2","3","4" initially. ReorderFields([0,2,3,1,4]) will reorder them as "0","2","3","1","4".

Not all drivers support this method. You can query a layer to check if it supports it with the OLCReorderFields capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existings features of the backing file/database should be updated accordingly.

This function is the same as the C function OGR_L_ReorderFields().

Parameters:

  | panMap | an array of GetLayerDefn()->GetFieldCount() elements which is a permutation of [0, GetLayerDefn()->GetFieldCount()-1].

Returns:
  OGRERR_NONE on success.

Since:
  OGR 1.9.0

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::ReorderFields().

void OGRLayerDecorator::ResetReading | ( |  | ) | `[virtual]`

Reset feature reading to start on the first feature.

This affects GetNextFeature().

This method is the same as the C function OGR_L_ResetReading().

Implements OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::ResetReading().

Referenced by OGRWarpedLayer::SetSpatialFilter().

OGRErr OGRLayerDecorator::SetAttributeFilter | ( | const char * | pszQuery | ) | `[virtual]`

Set a new attribute query.

This method sets the attribute query string to be used when fetching features via the GetNextFeature() method. Only features for which the query evaluates as true will be returned.

The query string should be in the format of an SQL WHERE clause. For instance "population > 1000000 and population < 5000000" where population is an attribute in the layer. The query format is normally a restricted form of SQL WHERE clause as described in the "WHERE" section of the OGR SQL tutorial. In some cases (RDBMS backed drivers) the native capabilities of the database may be used to interprete the WHERE clause in which case the capabilities will be broader than those of OGR SQL.

Note that installing a query string will generally result in resetting the current reading position (ala ResetReading()).

This method is the same as the C function OGR_L_SetAttributeFilter().

Parameters:

  | pszQuery | query in restricted SQL WHERE format, or NULL to clear the current query.

Returns:
  OGRERR_NONE if successfully installed, or an error code if the query expression is in error, or some other failure occurs.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SetAttributeFilter().

OGRErr OGRLayerDecorator::SetFeature | ( | OGRFeature * | poFeature | ) | `[virtual]`

Rewrite an existing feature.

This method will write a feature to the layer, based on the feature id within the OGRFeature.

Use OGRLayer::TestCapability(OLCRandomWrite) to establish if this layer supports random access writing via SetFeature().

This method is the same as the C function OGR_L_SetFeature().

Parameters:

  | poFeature | the feature to write.

Returns:
  OGRERR_NONE if the operation works, otherwise an appropriate error code.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::SetFeature().

OGRErr OGRLayerDecorator::SetIgnoredFields | ( | const char ** | papszFields | ) | `[virtual]`

Set which fields can be omitted when retrieving features from the layer.

If the driver supports this functionality (testable using OLCIgnoreFields capability), it will not fetch the specified fields in subsequent calls to GetFeature() / GetNextFeature() and thus save some processing time and/or bandwidth.

Besides field names of the layers, the following special fields can be passed: "OGR_GEOMETRY" to ignore geometry and "OGR_STYLE" to ignore layer style.

By default, no fields are ignored.

This method is the same as the C function OGR_L_SetIgnoredFields()

Parameters:

  | papszFields | an array of field names terminated by NULL item. If NULL is passed, the ignored list is cleared.

Returns:
  OGRERR_NONE if all field names have been resolved (even if the driver does not support this method)

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SetIgnoredFields().

OGRErr OGRLayerDecorator::SetNextByIndex | ( | long | nIndex | ) | `[virtual]`

Move read cursor to the nIndex'th feature in the current resultset.

This method allows positioning of a layer such that the GetNextFeature() call will read the requested feature, where nIndex is an absolute index into the current result set. So, setting it to 3 would mean the next feature read with GetNextFeature() would have been the 4th feature to have been read if sequential reading took place from the beginning of the layer, including accounting for spatial and attribute filters.

Only in rare circumstances is SetNextByIndex() efficiently implemented. In all other cases the default implementation which calls ResetReading() and then calls GetNextFeature() nIndex times is used. To determine if fast seeking is available on the current layer use the TestCapability() method with a value of OLCFastSetNextByIndex.

This method is the same as the C function OGR_L_SetNextByIndex().

Parameters:

  | nIndex | the index indicating how many steps into the result set to seek.

Returns:
  OGRERR_NONE on success or an error code.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SetNextByIndex().

void OGRLayerDecorator::SetSpatialFilter | ( | int | iGeomField,
|  | OGRGeometry * | poFilter |
| ) |  |  | `[virtual]`

Set a new spatial filter.

This method set the geometry to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGRGeometry::getEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This method makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the geometry field definition it corresponds to (as returned by GetLayerDefn()->GetGeomFieldDefn(iGeomField)->GetSpatialRef()). In the future this may be generalized.

Note that only the last spatial filter set is applied, even if several successive calls are done with different iGeomField values.

Note to driver implementators: if you implement SetSpatialFilter(int,OGRGeometry*), you must also implement SetSpatialFilter(OGRGeometry*) to make it call SetSpatialFilter(0,OGRGeometry*).

This method is the same as the C function OGR_L_SetSpatialFilterEx().

Parameters:

  | iGeomField | index of the geometry field on which the spatial filter operates.
  | poFilter | the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

Since:
  GDAL 1.11

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::SetSpatialFilter().

void OGRLayerDecorator::SetSpatialFilter | ( | OGRGeometry * | poFilter | ) | `[virtual]`

Set a new spatial filter.

This method set the geometry to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGRGeometry::getEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This method makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the layer (as returned by OGRLayer::GetSpatialRef()). In the future this may be generalized.

This method is the same as the C function OGR_L_SetSpatialFilter().

Parameters:

  | poFilter | the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::SetSpatialFilter().

void OGRLayerDecorator::SetSpatialFilterRect | ( | int | iGeomField,
|  | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY |
| ) |  |  | `[virtual]`

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as as the geometry field definition it corresponds to (as returned by GetLayerDefn()->GetGeomFieldDefn(iGeomField)->GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C function OGR_L_SetSpatialFilterRectEx().

Parameters:

  | iGeomField | index of the geometry field on which the spatial filter operates.
  | dfMinX | the minimum X coordinate for the rectangular region.
  | dfMinY | the minimum Y coordinate for the rectangular region.
  | dfMaxX | the maximum X coordinate for the rectangular region.
  | dfMaxY | the maximum Y coordinate for the rectangular region.

Since:
  GDAL 1.11

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::SetSpatialFilterRect().

void OGRLayerDecorator::SetSpatialFilterRect | ( | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY |
| ) |  |  | `[virtual]`

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as the layer as a whole (as returned by OGRLayer::GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C function OGR_L_SetSpatialFilterRect().

Parameters:

  | dfMinX | the minimum X coordinate for the rectangular region.
  | dfMinY | the minimum Y coordinate for the rectangular region.
  | dfMaxX | the maximum X coordinate for the rectangular region.
  | dfMaxY | the maximum Y coordinate for the rectangular region.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::SetSpatialFilterRect().

void OGRLayerDecorator::SetStyleTable | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set layer style table.

This method operate exactly as OGRLayer::SetStyleTableDirectly() except that it does not assume ownership of the passed table.

This method is the same as the C function OGR_L_SetStyleTable().

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SetStyleTable().

void OGRLayerDecorator::SetStyleTableDirectly | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set layer style table.

This method operate exactly as OGRLayer::SetStyleTable() except that it assumes ownership of the passed table.

This method is the same as the C function OGR_L_SetStyleTableDirectly().

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SetStyleTableDirectly().

OGRErr OGRLayerDecorator::SyncToDisk | ( |  | ) | `[virtual]`

Flush pending changes to disk.

This call is intended to force the layer to flush any pending writes to disk, and leave the disk file in a consistent state. It would not normally have any effect on read-only datasources.

Some layers do not implement this method, and will still return OGRERR_NONE. The default implementation just returns OGRERR_NONE. An error is only returned if an error occurs while attempting to flush to disk.

In any event, you should always close any opened datasource with OGRDataSource::DestroyDataSource() that will ensure all data is correctly flushed.

This method is the same as the C function OGR_L_SyncToDisk().

Returns:
  OGRERR_NONE if no error occurs (even if nothing is done) or an error code.

Reimplemented from OGRLayer.

Reimplemented in OGRMutexedLayer.

References OGRLayer::SyncToDisk().

int OGRLayerDecorator::TestCapability | ( | const char * | pszCap | ) | `[virtual]`

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the GetFeature() method is implemented in an optimized way for this layer, as opposed to the default implementation using ResetReading() and GetNextFeature() to find the requested feature id.

- OLCSequentialWrite / "SequentialWrite": TRUE if the CreateFeature() method works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the SetFeature() method is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain its own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via GetFeatureCount()) efficiently ... ie. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via GetExtent()) efficiently ... ie. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastSetNextByIndex / "FastSetNextByIndex": TRUE if this layer can perform the SetNextByIndex() call efficiently, otherwise FALSE.

- OLCCreateField / "CreateField": TRUE if this layer can create new fields on the current layer using CreateField(), otherwise FALSE.

- OLCCreateGeomField / "CreateGeomField": (GDAL >= 1.11) TRUE if this layer can create new geometry fields on the current layer using CreateGeomField(), otherwise FALSE.

- OLCDeleteField / "DeleteField": TRUE if this layer can delete existing fields on the current layer using DeleteField(), otherwise FALSE.

- OLCReorderFields / "ReorderFields": TRUE if this layer can reorder existing fields on the current layer using ReorderField() or ReorderFields(), otherwise FALSE.

- OLCAlterFieldDefn / "AlterFieldDefn": TRUE if this layer can alter the definition of an existing field on the current layer using AlterFieldDefn(), otherwise FALSE.

- OLCDeleteFeature / "DeleteFeature": TRUE if the DeleteFeature() method is supported on this layer, otherwise FALSE.

- OLCStringsAsUTF8 / "StringsAsUTF8": TRUE if values of OFTString fields are assured to be in UTF-8 format. If FALSE the encoding of fields is uncertain, though it might still be UTF-8.

- OLCTransactions / "Transactions": TRUE if the StartTransaction(), CommitTransaction() and RollbackTransaction() methods work in a meaningful way, otherwise FALSE.

- OLCIgnoreFields / "IgnoreFields": TRUE if fields, geometry and style will be omitted when fetching features as set by SetIgnoredFields() method.

This method is the same as the C function OGR_L_TestCapability().

Parameters:

  | pszCap | the name of the capability to test.

Returns:
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognised capabilities.

Implements OGRLayer.

Reimplemented in OGRMutexedLayer, and OGRWarpedLayer.

References OGRLayer::TestCapability().

The documentation for this class was generated from the following files:

- ogrlayerdecorator.h
- ogrlayerdecorator.cpp

Generated for GDAL by 1.7.1.